import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;

/**
 * Write a description of class Background here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Background extends World
{
    ArrayList<Box> boxListUp = new ArrayList<Box>();
    ArrayList<Box> boxListDown = new ArrayList<Box>();
    /**
     * Constructor for objects of class Background.
     * 
     */
    public Background()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(400, 100, 1); 
        setUp();
        if(Greenfoot.getRandomNumber(2)==1)
        {
            setCpuMove(true);
        }
    }
    public void setUp()
    {
        for (int i = 0; i<8; i++)
        {
            Box box = new Box();
            int xPlacement = 25+50*i;
            addObject(box,xPlacement,25);
            boxListUp.add(box);            
        }
        for (int i = 0; i<8; i++)
        {
            Box box = new Box();
            int xPlacement = 25+50*i;
            addObject(box,xPlacement,75);
            boxListDown.add(box);            
        }
        addObject(new BoxLost(),25,75);
    }
    public void bite(Box box)
    {
        int idUp = getIDofObject(box, boxListUp);
        int idDown= getIDofObject(box, boxListDown);
        if(!(idUp==-1))
        {
            for (int i = idUp; i<boxListUp.size();)
            {
                removeObject(boxListUp.get(i));
                boxListUp.remove(i);
            }
        }
        else if (!(idDown == -1))
        {
            for (int i = idDown; i<boxListUp.size();)
            {
                removeObject(boxListUp.get(i));
                boxListUp.remove(i);
            }
            for (int i = idDown; i<boxListDown.size();)
            {
                removeObject(boxListDown.get(i));
                boxListDown.remove(i);
            }
        }
    }
    public int getIDofObject(Box box, ArrayList<Box> list)
    {
        for (int i = 0; i<list.size(); i++)
        {
            if (list.get(i)==box)
            {
              return i;  
            }
        }
        return -1;
    }
    public void act()
    {
    }
    public void cpuMove()
    {
        bite(boxListDown.get(3));
    }
    boolean cpu= false;
    public void setCpuMove(boolean cpu)
    {
        if(cpu)
        {
            boolean cond1 = boxListUp.size()==1&&boxListDown.size()==2;
            boolean cond2 = boxListUp.size()==0&&boxListDown.size()==1;
            boolean cond3 = boxListUp.size()==1&&boxListDown.size()==0;
            if(cond1 || cond2 || cond3)
            {
                Greenfoot.setWorld(new Win());
            }
            else if(boxListUp.size()==boxListDown.size())
            {
                bite(boxListUp.get(boxListUp.size()-1));
            }
            else if((boxListUp.size()+1)<boxListDown.size())
            {
                bite(boxListDown.get(boxListUp.size()+1));
            }
            else if ((boxListUp.size()+1)==boxListDown.size())
            {
                int line = Greenfoot.getRandomNumber(2);
                if(line == 0)
                {
                    int number = Greenfoot.getRandomNumber(boxListUp.size());
                    bite(boxListUp.get(number));
                }
                else
                {
                    int number = Greenfoot.getRandomNumber(boxListDown.size()-1);
                    bite(boxListDown.get(number+1));
                }
                
            }
            
            cpu=false;
        }
    }
}
